// ** COMMON SETTINGS **
// display verbose debugging messages
#define DS_VERBOSE1(x) x
#define DS_VERBOSE2(x)

// logging
#define DS_LOGGING1(x) x
#define DS_LOGGING2(x) x

// external sorting
#define DS_INTERNAL_MEMORY_FOR_SORTING 650*1024*1024

// default template parameters of EdgeVector
// used by the first external bucket and by the input graph
#define DS_DEFAULT_BLOCK_SIZE 2*1024*1024
#define DS_DEFAULT_NO_OF_PAGES 1
#define DS_DEFAULT_PAGE_SIZE 4
#define DS_DEFAULT_PAGER lru_pager

// template parameters of the mst object which stores the result
#define DS_MST_BLOCK_SIZE 2*1024*1024
#define DS_MST_NO_OF_PAGES 1
#define DS_MST_PAGE_SIZE 4

// remove duplicates
#define DS_REMOVE_DUPLICATES(x) x
#define DS_DONT_REMOVE_DUPLICATES(x)

// randomize the input graph
#define DS_RANDOMIZE(x) x
#define DS_DONT_RANDOMIZE(x)

// node reduction implementation
#define DS_USE_BUCKETS(x) x
#define DS_USE_PQUEUE(x)

// ** BUCKETS IMPLEMENTATION **
// external buckets
#define DS_EXT_BUCKET_SIZE 1800000
// (The size of the first external bucket is the number of nodes which
//  fit in internal memory.)
#define DS_EXT_FIRST_BUCKET_SIZE 160*1000*1000

// template parameters of the external buckets
// (these values don't apply to the first external bucket)
#define DS_EXT_BLOCK_SIZE 512*1024
#define DS_EXT_PAGE_SIZE 1
#define DS_EXT_PREFETCH_POOL 4
#define DS_EXT_WRITE_POOL 4

// template parameters of the internal buckets
#define DS_INT_EDGES_PER_BLOCK 8
#define DS_INT_NO_OF_BLOCKS 1500000


// ** PQUEUE IMPLEMENTATION **
#define DS_PQUEUE_INTERNAL_MEMORY 500*1024*1024
#define DS_PQUEUE_MAX_SIZE 3*1000*1000
#define DS_PQUEUE_PREFETCH_POOL 50
#define DS_PQUEUE_WRITE_POOL 50
