/****************************************************
 *  Bachelor Project:                               *
 *  External Memory Minimum Spanning Trees          *
 *  by Dominik Schultes <mail@dominik-schultes.de>  *
 *                                                  *
 *                edgeVector.cpp                    *
 *                                                  *
 *  April 13, 2003                                  *
 ****************************************************/


#include "edgeVector.h"

//#include "../stxxl/algo/sort.h"
#include "../stxxl/algo/ksort.h"

/** Sorts the edges of the graph by weight. */
template <typename EdgeType, unsigned int blockSize,
	  unsigned int noOfPages, unsigned int pageSize>
void EdgeVector<EdgeType,blockSize,noOfPages,pageSize>::sortByWeight()
{
    // sort of STXXL
    // stxxl::sort(begin(),end(),WeightOrdering<EdgeType>(),DS_INTERNAL_MEMORY_FOR_SORTING);

    // ksort of STXXL
    stxxl::ksort(this->begin(),this->end(),GetWeight<EdgeType>(),DS_INTERNAL_MEMORY_FOR_SORTING);
}
